#!/bin/sh

echo "[Nmail] auto startup script - install"
if [ -d /etc/rc.d/init.d/ ]
then
  cp xmail /etc/rc.d/init.d/xmail
  ln -s ../init.d/xmail /etc/rc.d/rc0.d/K10xmail
  ln -s ../init.d/xmail /etc/rc.d/rc1.d/K10xmail
  ln -s ../init.d/xmail /etc/rc.d/rc2.d/S90xmail
  ln -s ../init.d/xmail /etc/rc.d/rc6.d/K10xmail
  ln -s ../init.d/xmail /etc/rc.d/rc3.d/S90xmail
  ln -s ../init.d/xmail /etc/rc.d/rc4.d/S90xmail
  ln -s ../init.d/xmail /etc/rc.d/rc5.d/S90xmail
  echo "  init.d path : /etc/rc.d/init.d/"
else
  cp xmail /etc/init.d/xmail
  ln -s ../init.d/xmail /etc/rc0.d/K10xmail
  ln -s ../init.d/xmail /etc/rc1.d/K10xmail
  ln -s ../init.d/xmail /etc/rc2.d/S90xmail
  ln -s ../init.d/xmail /etc/rc6.d/K10xmail
  ln -s ../init.d/xmail /etc/rc3.d/S90xmail
  ln -s ../init.d/xmail /etc/rc4.d/S90xmail
  ln -s ../init.d/xmail /etc/rc5.d/S90xmail
  echo "  init.d path : /etc/init.d/"
fi

if [ -f /etc/centos-release ]; then
	RELEASE_VERSION=`grep -o 'release [0-9]\+' /etc/centos-release`
	if [ "$RELEASE_VERSION" = "release 7" ]; then
		echo "[Nmail] xmail.service file install"
		/bin/cp -f xmail.service /usr/lib/systemd/system/xmail.service

		if [ ! -f /etc/systemd/system/multi-user.target.wants/xmail.service ]; then
			ln -s /usr/lib/systemd/system/xmail.service /etc/systemd/system/multi-user.target.wants/
		fi
		systemctl enable xmail.service
		systemctl daemon-reload
		echo "Complete!!!"
	fi
fi

echo "[Nmail] sendmail wrapper - link"
if [ -f /usr/sbin/sendmail ] && [ -f /usr/sbin/sendmail.backupByNmail ]
then
    echo "  sendmail wrapper path : /usr/sbin/sendmail (already exists, skip)"
else
    if [ -f /usr/sbin/sendmail ] && [ ! -f /usr/sbin/sendmail.backupByNmail ]
    then
        mv /usr/sbin/sendmail /usr/sbin/sendmail.backupByNmail
        ln -s /var/MailRoot/bin/sendmail.sh /usr/sbin/sendmail
        echo "  sendmail wrapper path : /usr/sbin/sendmail (backup, create)"
    else
      if [ -f /usr/lib/sendmail ] && [ ! -f /usr/lib/sendmail.backupByNmail ]
      then
          mv /usr/lib/sendmail /usr/lib/sendmail.backupByNmail
          ln -s /var/MailRoot/bin/sendmail.sh /usr/lib/sendmail
          echo "  sendmail wrapper path : /usr/lib/sendmail (backup, create)"
      else
          if [ ! -f /usr/sbin/sendmail ]
          then
              ln -s /var/MailRoot/bin/sendmail.sh /usr/sbin/sendmail
              echo "  sendmail wrapper path : /usr/sbin/sendmail (not exists, create)"
          else
              echo "  sendmail wrapper path : Error (already exists, skip)"
          fi
      fi
    fi
fi

echo "[Nmail] sendmail wrapper - permission change(SUID)"
chmod 755 /var/MailRoot/bin/sendmail
chmod 755 /var/MailRoot/bin/sendmail.sh
chmod +sx /var/MailRoot/bin/sendmail
chmod +sx /var/MailRoot/bin/sendmail.sh 
chmod +x /var/MailRoot/
chmod +x /var/MailRoot/bin/

echo "Complete!!!"
