#!/bin/sh

################################################################################
# User Config
################################################################################

# mysqldump path set
#MYSQLDUMP=/usr/local/mysql/bin/mysqldump
#MYSQLDUMP="/usr/local/mysql/bin/mysqldump --default-character-set=utf8"
#MYSQLDUMP="mysqldump --default-character-set=utf8"
MYSQLDUMP=mysqldump

# MySQL Host, Account, DB name
MYSQL_HOST=localhost
MYSQL_USER=nmail2
MYSQL_PASSWORD=YourPasssword
MYSQL_DB=nmail2

# Nmail PHP install path
NMAIL_HOME=/home/nmail2/

# Backup file path
BACKUP_DIR=/home/nmail2/_backup/


################################################################################
# Backup Start
################################################################################

FN=`date +"nmail2_"%Y%m%d"_"%H%M%S`
cd $NMAIL_HOME
echo "Backup Start..."

# DB Dump
echo "DB Backup : "$FN.sql.gz
$MYSQLDUMP -h$MYSQL_HOST -u$MYSQL_USER -p$MYSQL_PASSWORD --add-drop-table -a -Q -B $MYSQL_DB | gzip > $BACKUP_DIR/$FN.sql.gz
cd $NMAIL_HOME

# Webmail Source, Mail Server Config
echo "Source, Config Backup : "$FN.src.tar.gz
tar zcf $BACKUP_DIR/$FN.src.tar.gz \
--exclude="MailRoot/domains/*" \
--exclude="MailRoot/logs/*" \
--exclude="MailRoot/dnscache/*" \
--exclude="MailRoot/spool/*" \
--exclude="MailRoot/pop3links/*" \
--exclude="MailRoot/pop3linklocks/*" \
--exclude="MailRoot/pop3locks/*" \
nmail/ MailRoot/*

# Mail File - eml
echo "Mail Backup : "$FN.mails.tar.gz
tar zcf $BACKUP_DIR/$FN.mails.tar.gz MailRoot/domains/

# Log data
echo "Log Backup : "$FN.logs.tar.gz
tar zcf $BACKUP_DIR/$FN.logs.tar.gz MailRoot/logs/ weblogs/

# Upload data
echo "Upload Backup : "$FN.upload.tar.gz
tar zcf $BACKUP_DIR/$FN.upload.tar.gz upload/ --exclude="upload/session/*"

echo "Backup Complete!!!"
