<?
require_once('include/global.php');
require_once('include/admin_lib.php');
require_once("include/webhard_lib.php");
require_once('sadmin_conf.inc.php');

mail_server_check_limit();		// 메일서버가 동작중인지 확인

// set
	$CFG['TITLE'] = '<b>메일서버관리</b> >> <b>서버 설정</b>';


// get
	$row = array();
	$row['s_id_min_length'] = $G_MB[ID_MIN_LENGTH];
	$row['s_mbr_id_deny'] = @implode(', ', $G_SYS[MBR_ID_DENY]);
	$row['s_forward_domain_deny'] = @implode(', ', $G_SYS[FORWARD_DOMAIN_DENY]);
	$row['s_mail_upload_quota'] = ceil($G_SYS[UPLOAD_MAIL_MAX_SIZE]/1024/1024);
	$row['s_mail_bigfile_quota'] = ceil($G_SYS[UPLOAD_MAIL_BIGFILE_MAX_SIZE]/1024/1024);
	$row['s_mail_bigfile_count'] = $G_SYS[UPLOAD_MAIL_BIGFILE_COUNT];
	$row['s_mail_bigfile_day'] = $G_SYS[UPLOAD_MAIL_BIGFILE_DAY];
	$row['s_webhard_quota'] = ceil($G_SYS[UPLOAD_WEBHARD_MAX_SIZE]/1024/1024);
	$row['s_mail_box_restore_quota'] = ceil($G_SYS[UPLOAD_MAIL_BOX_RESTORE_MAX_SIZE]/1024/1024);
	$row['s_board_upload_quota'] = ceil($UPLOAD_MAX_SIZE/1024/1024);
	$row['s_webhard_use'] = $G_SYS[WEBHARD_USE];
	$row['s_virus_scan'] = $G_SYS[VIRUS_SCAN];
	$row['s_virus_return'] = $G_SYS[VIRUS_RETURN];
	$row['s_spam_rbl'] = @implode(', ', $G_SYS[S_SPAM_RBL]);
	$row['s_dns_direct'] = @implode(', ', $G_SYS[S_DNS_DIRECT]);

	$cfgs = nm_cfgfileget('server.tab');
	$row['s_default_domain'] = nm_cfg_val_get($cfgs, 'RootDomain');
	// [2007-03-09] HELO 도메인 입력
	$row['s_helo_domain'] = nm_cfg_val_get($cfgs, 'HeloDomain');
	$row['s_postmaster'] = nm_cfg_val_get($cfgs, 'PostMaster');
	$row['s_mail_quota'] = ceil(nm_cfg_val_get($cfgs, 'MaxMessageSize')/1024);


// data
	$view = array();
	// 도메인
	$q = "SELECT d_name FROM ".$TB['DOMAIN']." ORDER BY d_name";
	$dms = db_get_rows($q, true);
	$view['s_default_domain']= select_list_value($row['s_default_domain'], $dms['d_name'], $dms['d_name'], NULL, 0, 1);

	$view['s_helo_domain']= input_value($row['s_helo_domain'], 1);
	$view['s_postmaster']= input_value($row['s_postmaster'], 1);
	$view['s_id_min_length']= input_value($row['s_id_min_length'], 1);
	$view['s_mbr_id_deny']= htmlspecialchars_fix($row['s_mbr_id_deny']);
	$view['s_forward_domain_deny']= htmlspecialchars_fix($row['s_forward_domain_deny']);
	$view['s_mail_quota']= input_value($row['s_mail_quota'], 1);
	$view['s_spam_rbl']= htmlspecialchars_fix($row['s_spam_rbl']);
	$view['s_dns_direct']= htmlspecialchars_fix($row['s_dns_direct']);
	$view['s_mail_upload_quota']= input_value($row['s_mail_upload_quota'], 1);
	$view['s_mail_bigfile_quota']= input_value($row['s_mail_bigfile_quota'], 1);
	$view['s_mail_bigfile_count']= input_value($row['s_mail_bigfile_count'], 1);
	$view['s_mail_bigfile_day']= input_value($row['s_mail_bigfile_day'], 1);
	$view['s_webhard_quota']= input_value($row['s_webhard_quota'], 1);
	$view['s_mail_box_restore_quota']= input_value($row['s_mail_box_restore_quota'], 1);
	$view['s_board_upload_quota']= input_value($row['s_board_upload_quota'], 1);

	if ($row['s_webhard_use'] === NULL)
		$row['s_webhard_use'] = 0;
	$view['s_webhard_use']= select_list_value($row['s_webhard_use'], array_values($G['ISUSE']), array(1, 0), NULL, 0, 1);

	if ($G_SYS['MAIL_BOX_BACKUP_USE'] === NULL)
		$G_SYS['MAIL_BOX_BACKUP_USE'] = 0;
	$view['s_mail_box_backup_use']= select_list_value($G_SYS['MAIL_BOX_BACKUP_USE'], array_values($G['ISUSE']), array(1, 0), NULL, 0, 1);

	$webhard_demo_limit_f = webhard_demo_check('F');
	$webhard_demo_limit_s = webhard_demo_check('S');


	if ($row['s_virus_scan'] === false)
		$row['s_virus_scan'] = 0;
	$view['s_virus_scan']= select_list_value($row['s_virus_scan'], array_values($G['ISUSE']), array(1, 0), NULL, 0, 1);

	if ($row['s_virus_return'] === false)
		$row['s_virus_return'] = 0;
	$view['s_virus_return']= select_list_value($row['s_virus_return'], array('리턴메일 발송안함', '리턴메일 발송'), array(0, 1), NULL, 0, 1);

	// [2007-03-09] HELO 도메인 입력
	$view['s_helo_domain_sample'] = (preg_match('/[a-z]+/i', $row['s_default_domain'])) ? 'mail.'.$row['s_default_domain'] : 'mail.YourDomain.com';


	// [2009-03-23] 내부주소 위조 스팸 차단
	$view['s_spam_from_fake']= select_list_value($G_SYS['S_SPAM_FROM_FAKE'], array('검사 생략', '[스팸편지함]으로 배달(권장)', '메일을 받지 않고 바로 삭제'), array('SKIP', 'SPAM', 'DEL'), NULL, 0, 1);


// [2008-02-26]용량이 php.ini 설정과 맞지 않을 때 경고창을 띄우도록 함.
	$post_max_size = strtoupper(ini_get('post_max_size'));
	$post_max_size_unit = substr($post_max_size, strlen($post_max_size)-1);
	$post_max_size_int = substr($post_max_size, 0, strlen($post_max_size)-1);

	$upload_max_filesize = strtoupper(ini_get('upload_max_filesize'));
	$upload_max_filesize_unit = substr($upload_max_filesize, strlen($upload_max_filesize)-1);
	$upload_max_filesize_int = substr($upload_max_filesize, 0, strlen($upload_max_filesize)-1);


// skin view
	$CFG['ACTION'] = 'sserver_config_ok.php';
	nskinset('sadmin', 'sserver_config.html');
	include($NSKIN['view_layout']);


require_once('include/global_end.php');
?>