#!/bin/sh
# NmailAgent (Nmail PHP Addon)
# http://passkorea.net
#
# nmailagent        This shell script takes care of starting and stopping the NmailAgent.
#
# chkconfig: 345 90 10
# description:  NmailAgent
# processname: nmailagent
# pidfile: /var/run/NmailAgent.pid

if [ `uname -s` = "SunOS" ]; then
    NMAILAGENT_ROOT=/export/home/nmail2/tools/agent
else
    NMAILAGENT_ROOT=/home/nmail2/tools/agent
fi

cd $NMAILAGENT_ROOT

chmod 700 NmailAgent.sh.php NmailAgentChild.sh.php nmailagent nmailagent_inst.sh nmailagent.service

if [ -d /etc/rc.d/init.d/ ]
then
  cp nmailagent /etc/rc.d/init.d/nmailagent
  ln -s ../init.d/nmailagent /etc/rc.d/rc0.d/K10nmailagent
  ln -s ../init.d/nmailagent /etc/rc.d/rc1.d/K10nmailagent
  ln -s ../init.d/nmailagent /etc/rc.d/rc2.d/K10nmailagent
  ln -s ../init.d/nmailagent /etc/rc.d/rc6.d/K10nmailagent
  ln -s ../init.d/nmailagent /etc/rc.d/rc3.d/S90nmailagent
  ln -s ../init.d/nmailagent /etc/rc.d/rc4.d/S90nmailagent
  ln -s ../init.d/nmailagent /etc/rc.d/rc5.d/S90nmailagent
  echo "  init.d path : /etc/rc.d/init.d/"
else
  cp nmailagent /etc/init.d/nmailagent
  ln -s ../init.d/nmailagent /etc/rc0.d/K10nmailagent
  ln -s ../init.d/nmailagent /etc/rc1.d/K10nmailagent
  ln -s ../init.d/nmailagent /etc/rc2.d/K10nmailagent
  ln -s ../init.d/nmailagent /etc/rc6.d/K10nmailagent
  ln -s ../init.d/nmailagent /etc/rc3.d/S90nmailagent
  ln -s ../init.d/nmailagent /etc/rc4.d/S90nmailagent
  ln -s ../init.d/nmailagent /etc/rc5.d/S90nmailagent
  echo "  init.d path : /etc/init.d/"
fi

if [ -f /etc/centos-release ]; then
	RELEASE_VERSION=`grep -o 'release [0-9]\+' /etc/centos-release`
	if [ "$RELEASE_VERSION" = "release 7" ]; then
		echo "[Nmail] nmailagent.service file install"
		/bin/cp -f nmailagent.service /usr/lib/systemd/system/nmailagent.service

		if [ ! -f /etc/systemd/system/multi-user.target.wants/nmailagent.service ]; then
			ln -s /usr/lib/systemd/system/nmailagent.service /etc/systemd/system/multi-user.target.wants/
		fi
		systemctl enable nmailagent.service
		systemctl daemon-reload
		systemctl start nmailagent.service
		echo "Complete!!!"
	fi
fi

exit 0
