#!/usr/bin/php
<?
chdir(dirname(__FILE__));
require_once('../nmail/include/global.php');
require_once("include/file.php");


// 웹상에서의 실행방지.
if ($_SERVER['DOCUMENT_ROOT'] || $_SERVER['SERVER_SOFTWARE'])
{
	die("Access Denied");
}	// if()


// set
set_time_limit(0);
ini_set('memory_limit', '2047M');
$memory_limit = ini_get('memory_limit');
#echo "memory_get_usage: ".number_format(memory_get_usage()) . "\n"; 
$is_test = false;		// [2006-01-12] 테스트완료.


// db dump file
	$db_dump_nmail2 = "nmail2.sql";
	if ( !file_exists($db_dump_nmail2) )
	{
		die("DB dump file 을 찾을 수 없습니다.\n=> " . $db_dump_nmail2."\n");
	}	// if()

	// [2015-11-04] 다음 우편번호 API 적용
	/*
	$db_dump_nmail2_zipcode = "nmail2_zipcode.sql";
	if ( !file_exists($db_dump_nmail2_zipcode) )
	{
		die("DB dump file 을 찾을 수 없습니다.\n=> " . $db_dump_nmail2_zipcode."\n");
	}	// if()
	*/

	$db_dump_nmail2_luna = "nmail2_luna.sql";
	if ( !file_exists($db_dump_nmail2_luna) )
	{
		die("DB dump file 을 찾을 수 없습니다.\n=> " . $db_dump_nmail2_luna."\n");
	}	// if()



// db dump restore
	echo "DB dump file 을 import 하고 있습니다.\n서버사양에 따라 5~10분정도 걸릴 수 도 있으니 완료메세지가 나올때까지 기다려 주십시오.\n";

	$time_start = getmicrotime();

	// db table check
	if ($G_SYS[DB] == 'oracle') 
	{
		$q = "SELECT COUNT(*) FROM USER_OBJECTS WHERE OBJECT_NAME = '" . strtoupper($TB['MEMBER']) . "' AND OBJECT_TYPE = 'TABLE'";
	} else 
	{
		$q = "SHOW TABLES LIKE '".$TB['MEMBER']."'";
	}	// if()
	$mbrtable = db_get_one($q);
	if ($mbrtable)
	{
		echo "[생략]회원테이블(".$TB['MEMBER'].")이 이미 생성되어 있으므로 테이블 생성 작업은 생략합니다.\n";
	} else 
	{
		echo "회원테이블(".$TB['MEMBER'].")이 없으므로 테이블 생성 작업을 시작합니다.\n";

		$fp = fopen($db_dump_nmail2, "r");
		$db_dump = fread($fp, filesize($db_dump_nmail2));
		fclose($fp);

		// [2006-09-12]주석제거.
		if ($G_SYS[DB] == 'oracle') 
		{
			$_ex = explode("\n", $db_dump);
			$_sql = '';
			for ($i=0; $i<sizeof($_ex); $i++)
			{
				if (strpos($_ex[$i], '--') !== 0 && trim($_ex[$i]) != '')
					$_sql .= $_ex[$i]."\n";
			}	// for()
			$db_dump = $_sql;
		}	// if()

		$ar_query = explode(";", $db_dump);

		for ($i=0; $i<sizeof($ar_query)-1; $i++)		// 마지막 세미콜론(;)뒤의 문장은 주석뿐이거나 공백이므로 생략함.
		{
			db_query($ar_query[$i]);
		}	// for();
		unset($db_dump);
		unset($ar_query);

		echo "\n[성공]테이블 생성이 완료되었습니다. ( " . round(getmicrotime() - $time_start) . "sec )\n";
	}	// if()


	function db_import($file)
	{
		global $db, $is_test, $test, $time_start;

		// file read
		$fp = fopen($file, "r");
		$db_dump = fread($fp, filesize($file));
		fclose($fp);

		// 파일용량이 클때 메모리문제가 발생하지 않도록 분할해서 처리하기.
		$sp_buffer = 1024;
		$sp_end = strlen($db_dump);
		$sp = 0;
		$str_last = NULL;
		$exec_cnt = 0;

		// test file
		if ($is_test)
		{
			$test = '';		
		}	// if()

		while ($sp < $sp_end)
		{
			//echo "\n" . $sp;

			$db_dump_ss = substr($db_dump, $sp, $sp_buffer);
			$ar_query = explode(";", $db_dump_ss);
			unset($db_dump_ss);
			$ar_query_cnt = (is_array($ar_query)) ? sizeof($ar_query) : 0;
			for ($j=0; $j<$ar_query_cnt; $j++)
			{
				$q = $ar_query[$j];

				if ($j == ($ar_query_cnt-1))
				{
					// 분할후 마지막에 잘린 문자열 저장하기
					$str_last = $q;
					//echo "\nstr_last : " . $q;

				} else
				{
					// 분할후 마지막에 잘린 문자열 합치기
					if ($j == 0)
					{
						$q = $str_last . $q;
						$str_last = NULL;
					}	// if()

					// test file
					if ($is_test)
					{
						$test .= $q . ";";
					}	// if()

					#echo "[" . $j . " / " . $exec_cnt . "]" . $q ."\n";
					#error_log($q.";", 3, '_zipcode.sql');
					db_query($q);

					// view
					$exec_cnt++;
					if ($exec_cnt%5000 == 0)
					{
						echo "... " . number_format($exec_cnt) . "건 ( " . round(getmicrotime() - $time_start) . "sec )\n";
						flush();
					} else if ($exec_cnt%100 == 0)
					{
						$db->commit();
						echo ".";
						flush();
					}	// if()
				}	// if()
			}	// for()

			$db->commit();
			$sp = $sp + $sp_buffer;
		}	// while()

		// test file save
		if ($is_test)
		{
			require_once("include/file.php");
			file_write($file.".test", $test);
		}	// if()

		return $exec_cnt;		
	}	// function()

	// 대량 삽입을 위해 자동커밋을 사용하지 않음.
	$db->autoCommit(false);

	// 우편번호
	// [2015-11-04] 다음 우편번호 API 적용
	/*
	$q = "SELECT COUNT(*) FROM " . $TB['ZIPCODE'] . "";
	$zipcode_cnt = db_get_one($q);

	if ($zipcode_cnt == 48161)
	{
		echo "[생략]우편번호 데이타가 이미 들어가 있으므로 데이타 삽입은 생략합니다.\n";
		echo "  => 우편번호(".$TB['ZIPCODE'].") : ".number_format($zipcode_cnt)."건\n";
	} else 
	{
		echo "\n우편번호 데이타를 삽입하고 있는 중입니다...\n";

		// 데이타 초기화
		$q = "DELETE FROM " . $TB['ZIPCODE'] . "";
		db_query($q);
		$db->commit();

		$exec_cnt = db_import($db_dump_nmail2_zipcode);

		echo "\n[성공]우편번호 데이타를 " . number_format($exec_cnt) . "건 삽입했습니다. ( " . round(getmicrotime() - $time_start) . "sec )\n";
	}	// if()
	*/


	// 음력
	$q = "SELECT COUNT(*) FROM " . $TB['DIARY_LUNAR'] . "";
	$diary_lunar_cnt = db_get_one($q);

	if ($diary_lunar_cnt == 109938)
	{
		echo "[생략]음력 데이타가 이미 들어가 있으므로 데이타 삽입은 생략합니다.\n";
		echo "  => 음력(".$TB['DIARY_LUNAR'].") : ".number_format($diary_lunar_cnt)."건\n";
	} else 
	{
		echo "\n음력 데이타를 삽입하고 있는 중입니다...\n";

		// 데이타 초기화
		$q = "DELETE FROM " . $TB['DIARY_LUNAR'] . "";
		db_query($q);
		$db->commit();

		$exec_cnt = db_import($db_dump_nmail2_luna);

		echo "\n[성공]음력 데이타를 " . number_format($exec_cnt) . "건 삽입했습니다. ( " . round(getmicrotime() - $time_start) . "sec )\n";
	}	// if()


#require_once('include/global_end.php');
?>
