#!/usr/bin/php
<?

/*

	[2007-01-04]
	-. 일부 메일을 아웃룩에서 POP3로 가져가지 못하는 현상 보완.
		보낸편지함에 저장시 Unix 문서형식(crlf = \n)으로 메일파일이 저장되어있었습니다.
		이로 인해 보낸편지를 받은편지함으로 이동후 아웃룩에서 POP3 를 연결해서 메일을
		가져갈때 가져가지 못하는 문제가 발생하였습니다.
		이를 보완하고자 보낸편지함에 새로 저장되는 메일은 Window/DOS 문서형식인(\r\n)으로
		저장되도록 변경하였고, 기존 메일데이타는 현재 스크립트를 사용해 변환작업을 거치면 됩니다.
		궁금하신점은 http://passkorea.net 으로 문의주시기 바랍니다.

		특징)
			- 파일을 미리 확인하여 Unix 문서형식일때만 변환홤.
			- 변환된 파일명만 화면상에 출력시킴.
			- 파일 저장후에 '수정날짜'를 이전 수정날짜로 유지시킴.
			- 기존 데이타만 변환하면 되기 때문에 패치 적용후 1회만 사용하면 됩니다.

		사용예제)
			find /var/MailRoot/domains -type f -name '*.eml' -exec /home/nmail2/tools/lf_crlf_conv.php '{}' \;
			

*/

if ($_SERVER['argv'][1] == '')
{
	die("Usage : ".$_SERVER['argv'][0]." filename\n");
}	// if()

if (!file_exists($_SERVER['argv'][1]))
{
	die("존재하지 않는 파일입니다. => ".$_SERVER['argv'][1]."\n");
}	// if()

$fd = fopen($_SERVER['argv'][1], "r");
$contents = fread($fd, filesize($_SERVER['argv'][1]));
$fstat = fstat($fd);
$modtime = $fstat['mtime'];
fclose($fd);

$sp = strpos($contents, "\r\n");

if ($sp === false)
{
	$contents2 = str_replace("\n", "\r\n", $contents);
	if (strcmp($contents, $contents2))
	{
		$fh = fopen($_SERVER['argv'][1], 'w');
		fwrite($fh, $contents2);
		fclose($fh);
		touch($_SERVER['argv'][1], $modtime);
		echo "Convert - ".$_SERVER['argv'][1]."\n";
	}	// if()
}	// if()

?>